// Magic box  version Ciucc-box 1.8.9 102/11/22   by F.Lucesio
// Verison history
// 1.0  base
// 1.1  aggiunto led rosso (?)
// 1.2  aggiunta funzione pausa 
// 1.3  Inserito controllo volume con potenziometro
// 1.4  Rivoluzionato cartelle contenuti: spostato oracle su advert  suddiviso spot e sentenze, nuova cartella 5
// 1.5  Aggiunto equalizzazione attiva  su click singolo senza player attivo
// 1.6  Aggiunta gestione della cartella  segreta 08, adv in ogni pezzo e ridotto a 1 pausa spot/afo
// 1.7  Trappola oracolo accesso casuale (uno su 3333 ce la fa) + afo afo spot + shortcuts + classica 
// 1.8  Ridistribuite frasi aforismi su cartelle 6 e 10 dopo averle sottratte ad ADVERT  , AGGIUNTE ALTRE 2 SHORT KEY


#include "SoftwareSerial.h"
#include "DFRobotDFPlayerMini.h"

// mp3 palyer settings ------------------
// Use pins 2 and 3 to communicate with DFPlayer Mini
static const uint8_t PIN_MP3_TX = 3; // Connects to module's RX 
static const uint8_t PIN_MP3_RX = 2; // Connects to module's TX 
SoftwareSerial softwareSerial(PIN_MP3_RX, PIN_MP3_TX);

// Create the Player object
DFRobotDFPlayerMini Player;


// PERSONALIZZAZIONE --------------------------------------------------

// costanti

const byte nadv = 35;                         // numero avvisi pubblicitari
const int mxr[6] = {1045,1000,69,27,442,27};  // numero elementi per ogni modalita
const byte nintro = 34;                       // numero intro diverse
const int nafor  = 391;                      // numero aforismi/sentenze 
const int naseg  = 252;                      // numero aforismi/sentenze segreti
const byte istvol = 20;                       // isteresi volume sulla lettura analog


// digital I/O
const byte pin_LED =5;     // led giallo   Lara = 5
const byte pin_LED2 =6;    // led rosso  
const byte speakerPin = 9; // cicalino (opzionale) 
const byte pinmp3 =10;     // per rilevare attivita' del player: (ON = fermo)
const byte buttonPin = 8;  // pulsante
const byte pinvol = A6;    // potenziometro volume


// definizione variabili ----------------------------------------------
// tempo

long int Tempo;          // per ciclo principale
long int Tp;             // per lampeggio led pausa
long int startplay;      // fissa il tempo di inizio di un item 

// temporizzatori (valori in millisecondi)
// ciclo generale (ogni 3,333 secondi)
int Ig = 3999;
// durata pulsante premuto per accesso direct: si attiva se maggiore di
int Ib = 1000;

// altri temporizzamenti
int tempi[14];           // per modalita random guidata (max 13 step)---v
byte passo = 0;          // numero step (premute di bottone)
int punt;                // puntatore all'elemento selezionato
int puntcor;             // ultimo item suonato con punt


// flags binari

bool aradio = false;      // modo radio on/off :(significa playare in modo continuo senza terminare il pezzo)                    
bool debug = false;       // spara nel canale seriale delle informazioni utili
bool pausa = false;       // indica lo stato pause del player 
bool fledon = false;      // per lampeggio in pausa
bool flseg = false;       //  per modalita 5 
bool shcut = false;       //  per evitare oracolo quando si ascolta da una key

 

// varie

byte mode = 0;           // modalita   0 = default   1 = canzoni  2 = favole  3 = favolelunghe 4 = oracolo 
byte modest = 0;         // modalita  di partenza, serve per rientrare dopo una modalita  non permanente
byte spot =0;            // per intervallare la pubblicita
byte orastart = 0;       // per attendere la fine del messaggio oracolo
int  t; 
int volume = 0;
int volumep = 0;
byte volump3 = 4;
byte eq = 0;



// pulsante

byte buttonState = 0;     // stato pulsante
byte lastButtonState = 0; // stato precedente
int startPressed = 0;     // pulsante premuto
int endPressed = 0;       // pulsante rilasciato
int holdTime = 0;         // per timer pulsante on
int idleTime = 0;         // per timer pulsante off


void setup()
{
 Tempo=millis();  //inizializza timers
 Tp=millis();
 // inizializza pulsante 
 pinMode(pin_LED, OUTPUT);
 pinMode(pin_LED2, OUTPUT);
 pinMode(buttonPin, INPUT);
 pinMode(pinmp3, INPUT);
 pinMode(speakerPin, OUTPUT);
 pinMode(pinvol, INPUT);

 Serial.begin(9600);
 // Init serial port for DFPlayer Mini
 softwareSerial.begin(9600);
 // Start communication with DFPlayer Mini
 if (Player.begin(softwareSerial)) {
 // Set volume (0 to 30).
    Player.volume(volump3);
  } else {
    if(debug) Serial.println("Connecting to DFPlayer Mini failed!");
    tone(speakerPin,1000,300);
  digitalWrite(pin_LED2,HIGH);  //rosso fisso = malfunzionamento mp3
  }
 // messaggio di benvenuto random  
 // attende la pressione del tasto
 // lasciando il led giallo acceso
 digitalWrite(pin_LED,HIGH);
 while(digitalRead(buttonPin) == LOW) 
     delay(50);
 digitalWrite(pin_LED,LOW); 
 randomSeed(analogRead(0)+millis());  // init random 
 if(debug) Serial.println(millis());
 t=millis();
 while (t > nintro)
  t=t-nintro;
 if(t == 0) 
    t = 1;
 // setta volume in base al potenziometro la prima volta
 volume = analogRead(pinvol);
 volump3 = map(volume, 0, 1023, 0, 30);
 Player.volume(volump3);
 Player.playFolder(1, t);  
 if(debug) Serial.println(t);
 delay(5000); // per evitare pressioni eccessive  di bottone 
 }


void loop()
{


//  ciclo principale ----------------------------------------------------------------

if (millis()-Tempo >= Ig) 
{
   Tempo=millis();


  // in modalita aradio delle canzoni ripete random alla fine della corrente
  // ogni pezzo  manda la pubblicita o la frase  a intervalli 2+1 (P F P F P S)
   if(mode  < 2  &&  aradio && !pausa && digitalRead(pinmp3) == HIGH) {
        spot++;
		if(spot > 6)
			spot =1;
        if(spot !=2 && spot !=4 && spot !=6)
            punt=random(mxr[mode]+1);
        else{
           if(spot == 6)
		     punt = random(nadv)+1;
           else {
			 if(flseg)
		        punt = random(naseg)+1;
             else
              	punt = random(nafor)+1;			 
           }
		}         

   }
   
   
  // seconda trappola oracolo: uno su 3333 ce la fa
 	if (random(3333) == 333 && mode < 2  && shcut==false) {
	     mode = 4;
	     punt =0;
	     Player.playFolder(2,19); // entra in modalita' oracolo  
    }
   
    // dopo 3 chiamate oracle  torna in modalita' canzoni
    if(mode  == 4 && digitalRead(pinmp3) == HIGH) {
        if(orastart > 2) {
         orastart = 0; 
         mode = modest;
        }
    }
  
  

 
   // tasto singolo = pausa 
       if (passo == 1){
      
        if(digitalRead(pinmp3) == HIGH){  // non c'e' attivita 
             if(!pausa){
               // se non e' gia in pausa si cambia EQ
               eq++;
               if(eq > 5)
                  eq=0;
               Player.EQ(eq);
               Player.playFolder(2,21 + eq);
             }
             else {
                pausa = false;
                Player.start();
                fledon = false;
                digitalWrite(pin_LED,LOW);
             }
      }
      else {
         pausa = true;
         Player.pause();     
      }
  
    }

     // azioni che si attuano con passo < 2,3 > ovvero doppio click secondo il contesto-----

    // il double click restituisce spesso passo = 3
    if (passo == 2)
     passo=3;
 
    // start segreti trasparenti (si attiva con una determinata canzone ed entro 20 secondi)
    if (puntcor == 107 && (millis()-startplay) < 20000 && mode == 0 && passo == 3){
           // inserire play dell'intro segreti
           Player.playFolder(2,20);
           digitalWrite(pin_LED,HIGH);
           passo = 0; 
    } 
  
  
    if (passo == 3) {
 

     // in modalita stories avanza di una
    if(mode >1){
             puntcor++;
             if(puntcor > mxr[mode])
                 puntcor=1;
                 punt = puntcor;
             }

     // attiva o disattiva la modalita  radio    
            if(mode < 2) {
            if(!aradio){ 
               aradio = true;
               Player.playFolder(2,14);  // funzione radio attivata
            }
            else
            {
               Player.playFolder(2,15);  // funzione radio disattivata
               aradio = false;
               spot = 0;
            }
        }

    }

           
 


// ----------------- fine sezione doppio click

if(debug) {
      Serial.print(" puntcor= ");  
      Serial.print(puntcor);      
      Serial.print(" punt= ");  
      Serial.print(punt);       
      Serial.print(" mode= ");   
      Serial.print(mode);
      Serial.print(" radio= ");
      Serial.print(aradio);
      Serial.print(" volume= ");
      Serial.print(volume);     
      Serial.print(" passo= ");  
      Serial.println(passo);
}


   //led modalita 
   lampeggia(mode);


   // hash 
   if(passo > 3) {
       punt = hashnum();
       if(random(4) == 3){
           if(mode != 4){    
              Player.playFolder(2,16);  // hai pescato il numero
              delay(5000);
			  parlanum(punt);
           
		   }
	   }
	 }  

        
//guarda se c'e da mandare qualcosa
     
if (punt > 0) {
  
    if(mode < 2){  // spot e sentenze 
        
		switch(spot) {
		
        case 6: 		
			Player.playFolder(7,punt); 
			break;
		case 2:
		    if (flseg)
			    Player.playFolder(8,punt);
			else {				 
				 if (punt > 250)
				    Player.playFolder(10,punt-250);  // aforismi distribuiti su 2 folder : 6 e 10 
				 else
					Player.playFolder(6,punt); 		 		 
				 }
			break;

		case 4:
		    if (flseg)
			    Player.playFolder(8,punt);
			else {
				if (random(13)==3)
                    Player.playFolder(3,random(mxr[2]+1));  // ogni tanto sgancia una fiaba corta
                else{				 
				   if (punt > 250)
				    Player.playFolder(10,punt-250);
				   else
					Player.playFolder(6,punt); 		 		 
				   }			
				}
        
			break;		

		default: 
            if(mode == 0) 
               Player.play(punt);	
            if(mode == 1) 
               Player.playMp3Folder(punt);		
		    break;
		}
	}	
	
	if(mode ==2 || mode ==3)  
        Player.playFolder(mode+1,punt);
    if(mode == 4){
        Player.advertise(punt);  //oracolo
        orastart++;
    } 
    if(mode == 5)
        Player.playFolder(5,punt);  //brani segreti 
  
  startplay = millis();
  puntcor = punt;  
  punt = 0; 
 }   

    
 passo = 0;


 
} 
// ------------------------- fine ciclo generale temporizzato ---------------------



// lampeggio led giallo in pausa

if(pausa) {
  if((millis()- Tp) > 300){
    Tp = millis();
      if(fledon){
      digitalWrite(pin_LED,LOW);
      fledon = false;
      }
    else {
      digitalWrite(pin_LED,HIGH);
      fledon = true;  
      }
  }
}

//regolazione volume 


volume = analogRead(pinvol);

if(abs(volume-volumep) > istvol){
  volump3 = map(volume, 0, 1023, 0, 30);
  if(debug) Serial.print("Modifico volume:");
  if(debug) Serial.println(volump3);
  volumep = volume;
  Player.volume(volump3);
   }
     
// Controlla attivita del pulsante


  buttonState = digitalRead(buttonPin); 

  if (buttonState != lastButtonState) { 

 // Pulsante premuto
  if (buttonState == HIGH) {

      startPressed = millis();
      idleTime = startPressed - endPressed; 
       if (idleTime >50 and idleTime < Ib) {
          tempi[passo] = idleTime;
          passo++;
          tone(speakerPin,1000+random(1000),200);
          if (passo > 13)
          passo=13; 
       }
      
  // pulsante rilasciato 
  } else {
      endPressed = millis();
      holdTime = endPressed - startPressed;
      if (holdTime >50) {
           tempi[passo] = holdTime;
           passo++;
           Tempo = millis();
           if (passo > 13)  // al massimo 13 step di pulsante
             passo=13;       
      }
    //richiamo indicizzato 
      if (holdTime >= Ib && mode != 4) {
          
		  punt = indica();
		  if(punt == 1313){   // trappola letture segrete 
			   mode =5;   
		     punt =0;
      }
          if(mode == 4)
             punt =0;
          passo=0;
          if(punt == 0){
                switch(mode) {
                  case 0:
                   Player.playFolder(2,18); // entra in modalita' mp3
                   mode =1; 
				   Ig = 5000;  // allunga il ciclo per evitare salti 
                   puntcor = 0; // azzera eventuale puntatore
                   break;               
                 case 1:
                   Player.playFolder(2,12); // entra in modalita' favole
                   mode =2; 
                   puntcor = 0; // azzera eventuale puntatore
                   break;        
                  case 2:
                   Player.playFolder(2,13); // entra in modalita' favole lunghe 
                   mode = 3;
                   puntcor = 0; // azzera eventuale puntatore
                   break; 
                 case 4:
                    Player.playFolder(2,19); // entra in modalita' oracolo  
                    break;
                 case 5: 
                    if (!flseg){
			 Player.playFolder(2,17); // intro modalita letture segrete    
                         puntcor = 0; // azzera eventuale puntatore
                       flseg = true;
					         }
					else {
					   mode = 0;
					  Player.playFolder(2,27); // ritorno al canto 
					}	
					break;
               }				
        }
        else {

            if(!segreto()){  //trap segreti e shortcuts
            //previene indici fuori range
                while(punt > mxr[mode])        
                    punt = punt - mxr[mode];
                Player.playFolder(2,11);  // serviamo il numero
                delay(4500);
		        parlanum(punt);
            }
            
		    }	 
      }
    }
  }

  lastButtonState = buttonState;        // save state for next loop

}  // fine loop principale 
 



// FUNZIONI -----------------------------------------------------------
   

// funzione indica
// consente di formare un numero di 4 cifre 
// fornendo il numero di impulsi nella sequenza esattamente 
// come vengono visualizzati a led: migliaia, centinaia, decine, unita
// il led guida la scelta lampeggiando in negativo 
// ad ogni pressione del tasto con pausa lunga 1 sec. fra le cifre


int indica() {
 int Tpause = 2000; //pausa per stabilire il passaggio ad altra cifra
 long int  Tprec;
 int currentButtonState;
 int previousButtonState;
 byte cifre[] = {0,0,0,0,0};  // vettore per creare il puntatore a 4 cifre
 byte cifra = 0; // punta a : 1 = migliaia  2 = centinaia 3 = decine 4 = unita min  0 = flag 
 delay(300); // test per vedere se si evita prima cifra 1 

do {

 Tprec=millis();
 do {
    previousButtonState = currentButtonState;
    currentButtonState = digitalRead(buttonPin);
    digitalWrite(pin_LED,HIGH);
    if (previousButtonState == HIGH and currentButtonState == LOW) { // assumes LOW = pressed
      Tprec = millis();
      cifre[cifra]++;
      // trappola mode 4 oracolo (si preme 13 volte in una cifra)
      if(cifre[cifra] == 13){
          mode = 4;
          cifre[cifra]=0;
        }
      digitalWrite(pin_LED,LOW);
      delay(300);
      digitalWrite(pin_LED,HIGH); 
    }

 } while (millis()-Tprec < Tpause);

    digitalWrite(pin_LED,LOW);
    delay(1000); 
    if(debug) {
       Serial.print("indice diretto: cifra #");
       Serial.print(cifra);
       Serial.print("  = ");
       Serial.println(cifre[cifra]);
    }
    
    cifra++;
 } while (cifra <4);

digitalWrite(pin_LED,LOW);
cifra=0;
return cifre[0]*1000+cifre[1]*100+cifre[2]*10+cifre[3];
}



// funzione hashnum
int hashnum(){
int i;
long int t;
float k=2;
for (i = 1; i<=passo; i++) {
  k=tempi[i]*log(k)+k;
if(debug)  Serial.println(tempi[i]);
  }
t=abs(k*333);
while (t > mxr[mode])
  t=t-mxr[mode];
  
return t;

}


void parlanum(int p){
int i,c;   
for(i=3;i>-1;i--){
  c = p/pow(10,i);
  if(c == 0){
    Player.playFolder(2,10);
    delay(3000);
    }
    else {
      Player.playFolder(2,c);
      delay(3000);
    }
  p = p - c*pow(10,i);
}

}


void lampeggia(int n){
int i;
for (i = 1; i<=n+1; i++)
  {
    digitalWrite(pin_LED2,HIGH);
    delay(50);
    digitalWrite(pin_LED2,LOW);
    delay(150);
  }

}

bool segreto(){
bool s = false;
byte f = 13;
byte g;

 switch(punt) {
 case 3245 :
   g=1;
   s =true; 
   break;
 case 3466 :
   g=2;
   s =true; 
   break;
 case 3776 :
   g=3;
   s =true; 
   break;
 case 4778 :
   g=4;
   s =true;
   break; 
 case 5779 :
   g=5;
   s =true;
   break;
 case 8770 :
   g=6;
   s =true;
   break; 
 case 9771 :
   g=7;
   s =true; 
   break;
 case 9564 :
   g=8;
   s =true;
   break; 
 case 8742 :
   g=9;
   s =true;
   break; 
 case 8879 :
   g=10;
   s =true;
   break; 
 case 8990 :
   g=11;
   s =true;
   break; 
 case 6321 :
   g=12;
   s =true;
   break; 
 case 3234 :
   g=13;
   s =true;
   break; 
 case 3436 :
   g=14;
   s =true;
   break; 
 case 7312 :
   g=15;
   s =true;
   break; 
 case 8435 :
   g=16;
   s =true;
   break; 
 case 8812 :
   g=17;
   s =true;
   break; 
 case 9132 :
   g=18;
   s =true;
   break; 
 case 1539 :
   g=19;
   s =true;
   break; 
 case 8412 :
   g=20;
   s =true;
   break; 
 case 2563 :
   g=21;
   s =true;
   break; 
 case 5423 :
   g=22;
   s =true;
   break; 
 case 5470 :
   g=23;
   s =true;
   break; 
 case 8945 :
   g=24;
   s =true;
   break; 
 case 8654 :
   g=25;
   s =true;
   break; 
 case 6421 :
   g=26;
   s =true;
   break; 
 case 6004 :
   g=27;
   s =true;
   break; 
 case 4006 :
   g=28;
   s =true;
   break; 
 case 7079 :
   g=29;
   s =true;
   break; 
 case 7556 :
   g=30;
   s =true;
   break; 
 case 1793 :
   g=31;
   s =true; 
   break;
 } 
 
 // i segreti vanno solo in mode = 3 !
 
 if(mode != 3)
	 s = false;
 
 if(s) {
   Player.playFolder(f,g);
   punt =0;
     if(debug) {
     Serial.print("Segreto beccato !  dir = ");
     Serial.print(f);
     Serial.print(" item = ");
     Serial.print(g);
     Serial.print(" punt = ");
     Serial.print(punt);       
   }
}
// shortcuts  (si ottengono da 1100 a 1300)
     
	if (punt > 1100 && punt < 1200) {
	   // scorciatoia favole brevi
	   Player.playFolder(3,punt-1100);
       punt = 0;
       s = true;	   
	}	
	
	if (punt > 1200 && punt < 1300) {
	   // scorciatoia favole lunghe
	   Player.playFolder(4,punt-1200);
       punt = 0;
       s = true;	   
	}		
	
	if (punt > 1300 && punt < 1400) {
	   // scorciatoia musica classica	   
	   Player.playFolder(9,punt-1300);
       punt = 0;
       s = true;	   
	}			
	
  if (punt > 2100 && punt < 2200) {
     // scorciatoia SPOT   
     Player.playFolder(7,punt-2100);
       punt = 0;
       s = true;    
}   

  if (punt > 2200 && punt < 2300) {
     // scorciatoia racc segreti    
     Player.playFolder(5,punt-2200);
       punt = 0;
       s = true;    
}    

if (s) shcut=true; // disabilita possibilità oracolo se attivo segreto  

return s;

}
